<template>
  <div class="container">
    <div class="text-center pt-4">
      <h2>
        <b>Update Password</b>
      </h2>
    </div>
    <form>
      <div class="mb-3">
        <label for="exampleInputEmail1" class="form-label">Email address</label>
        <input type="email" class="form-control" v-model="email" required />
        <div id="emailHelp" class="form-text text-danger" v-if="msg.email">
          {{ msg.email }}
        </div>
      </div>
      <div class="mb-3">
        <label for="exampleInputPassword1" class="form-label">Password</label>
        <div class="input-group mb-3">
          <input
            :type="typeFormPass ? 'password' : 'text'"
            class="form-control"
            v-model="password"
            required
          />
          <button
            class="btn btn-outline-secondary"
            type="button"
            @click="handletypeFormPass"
          >
            <i v-if="typeFormPass" class="bi bi-eye-fill"></i>
            <i v-else class="bi bi-eye-slash-fill"></i>
          </button>
        </div>
        <div id="emailHelp" class="form-text text-danger" v-if="msg.password">
          {{ msg.password }}
        </div>
      </div>
      <div class="mb-3">
        <label for="exampleInputPassword1" class="form-label">Confrim Password</label>
        <div class="input-group mb-3">
          <input
            :type="typeFormComPass ? 'password' : 'text'"
            class="form-control"
            v-model="comfirmpassword"
            required
          />
          <button
            class="btn btn-outline-secondary"
            type="button"
            @click="handletypeFormConfrimPass"
          >
            <i v-if="typeFormComPass" class="bi bi-eye-fill"></i>
            <i v-else class="bi bi-eye-slash-fill"></i>
          </button>
        </div>
        <div id="emailHelp" class="form-text text-danger" v-if="msg.confirmpassword">
          {{ msg.confirmpassword }}
        </div>
      </div>
      <button type="button" @click="submit" class="btn btn-success">
        Update Password
      </button>
    </form>
  </div>
</template>

<script>
import { mapGetters } from "vuex";
import { mapMutations } from "vuex";

export default {
  name: "login",
  data() {
    return {
      typeFormPass: true,
      typeFormComPass: true,
      email: "",
      password: "",
      comfirmpassword: "",
      msg: [],
      type: "password",
    };
  },
  watch: {
    email(value) {
      this.email = value;
      this.validateEmail(value);
    },
    password(value) {
      this.password = value;
      this.validatePassword(value);
    },
    comfirmpassword(value) {
      this.comfirmpassword = value;
      this.validatecomfirmpassword(value);
    },
  },

  computed: {
    ...mapGetters({
      transactions: "auth/transactions",
      user: "auth/user",
      alert: "alert/alert",
      alertError: "alert/alertError",
      alertText: "alert/alertText",
    }),
  },

  methods: {
    ...mapMutations({
      setAuth: "auth/set",
      setIsLogin: "auth/setisLogin",
      getAlert: "alert/getAlert",
      closeAlert: "alert/closeAlert",
    }),

    authProvider(provider) {
      let url = "/api/Auth/Sosialite/" + provider;
      axios
        .get(url)
        .then((res) => {
          let data = res.data;
          console.log(data.url);
          window.location.href = data.url
        })
        .catch((err) => {
          console.error(err);
        });
    },

    submit() {
      let formData = {
        email: this.email,
        password: this.password,
        password_confirmation : this.comfirmpassword
      };

      axios({
        method: "post",
        url: "/api/Auth/Update-Password",
        data: formData,
      })
        .then((response) => {
          let dataUserLogin = response.data;
          this.getAlert("Update Password Berhasil");
          this.$router.push("/Login");
        })
        .catch((error) => {
          alert("catch error");
          console.log(error);
        });
    },

    validateEmail(value) {
      if (/^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/.test(value)) {
        this.msg["email"] = "";
      } else if (value.length === 0) {
        this.msg["email"] = " Email Address is Reuqired";
      } else {
        this.msg["email"] = "Invalid Email Address";
      }
    },
    validatePassword(value) {
      let difference = 8 - value.length;
      if (value.length < 8 && value.length > 0) {
        this.msg["password"] =
          "Must be 8 characters! " + difference + " characters left";
      } else if (value.length === 0) {
        this.msg["password"] = "Password is Required";
      } else {
        this.msg["password"] = "";
      }
    },
    handletypeFormPass() {
      this.typeFormPass = !this.typeFormPass;
    },

    validatecomfirmpassword(value) {
      let difference = 8 - value.length;
      if (value.length < 8 && value.length > 0) {
        this.msg["confirmpassword"] =
          "Must be 8 characters! " + difference + " characters left";
      } else if (value.length === 0) {
        this.msg["confirmpassword"] = "Confirm Password is Required";
      } else {
        this.msg["confirmpassword"] = "";
      }
    },
    handletypeFormConfrimPass() {
      this.typeFormComPass = !this.typeFormComPass;
    },
  },
};
</script>
